# source: https://stackoverflow.com/questions/45995784/how-to-set-compiler-options-with-cmake-in-visual-studio-2017
# log all *_INIT variables
get_cmake_property(_varNames VARIABLES)
list (REMOVE_DUPLICATES _varNames)
list (SORT _varNames)
set(PRINT_COMPILER_OPTIONS false)
if(PRINT_COMPILER_OPTIONS)
    message(STATUS "Default Compiler Options ===================================================")
    foreach (_varName ${_varNames})
        if (_varName MATCHES "_INIT$")
            message(STATUS "${_varName}=${${_varName}}")
        endif()
    endforeach()
    message(STATUS "End Default Compiler Options ===================================================")
endif()

if (MSVC AND ("CMAKE_C_FLAGS_INIT" IN_LIST _varNames))
    # remove default warning level from CMAKE_CXX_FLAGS_INIT
    string (REGEX REPLACE "/W[0-4]" "" CMAKE_C_FLAGS_INIT ${CMAKE_C_FLAGS_INIT})
    string(REPLACE "/MDd" "/MTd" CMAKE_C_FLAGS_DEBUG_INIT ${CMAKE_C_FLAGS_DEBUG_INIT})
    string(REPLACE "/MD" "/MT" CMAKE_C_FLAGS_MINSIZEREL_INIT ${CMAKE_C_FLAGS_MINSIZEREL_INIT})
    string(REPLACE "/MD" "/MT" CMAKE_C_FLAGS_RELEASE_INIT ${CMAKE_C_FLAGS_RELEASE_INIT})
    string(REPLACE "/MD" "/MT" CMAKE_C_FLAGS_RELWITHDEBINFO_INIT ${CMAKE_C_FLAGS_RELWITHDEBINFO_INIT})
endif()

if (MSVC AND ("CMAKE_CXX_FLAGS_INIT" IN_LIST _varNames))
    string (REGEX REPLACE "/W[0-4]" "" CMAKE_CXX_FLAGS_INIT ${CMAKE_CXX_FLAGS_INIT})
    string(REPLACE "/MDd" "/MTd" CMAKE_CXX_FLAGS_DEBUG_INIT ${CMAKE_CXX_FLAGS_DEBUG_INIT})
    string(REPLACE "/MD" "/MT" CMAKE_CXX_FLAGS_MINSIZEREL_INIT ${CMAKE_CXX_FLAGS_MINSIZEREL_INIT})
    string(REPLACE "/MD" "/MT" CMAKE_CXX_FLAGS_RELEASE_INIT ${CMAKE_CXX_FLAGS_RELEASE_INIT})
    string(REPLACE "/MD" "/MT" CMAKE_CXX_FLAGS_RELWITHDEBINFO_INIT ${CMAKE_CXX_FLAGS_RELWITHDEBINFO_INIT})
endif()